## fltk1.3 1.3.8

=== fluid/CMakeLists.txt ===
#
# CMakeLists.txt to build fluid for the FLTK project using CMake (www.cmake.org)
#
# Copyright 1998-2021 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

set (CPPFILES
  CodeEditor.cxx
  Fl_Function_Type.cxx
  Fl_Group_Type.cxx
  Fl_Menu_Type.cxx
  Fl_Type.cxx
  Fl_Widget_Type.cxx
  Fl_Window_Type.cxx
  Fluid_Image.cxx
  about_panel.cxx
  align_widget.cxx
  alignment_panel.cxx
  code.cxx
  factory.cxx
  file.cxx
  fluid.cxx
  function_panel.cxx
  template_panel.cxx
  undo.cxx
  widget_panel.cxx
)

# ExternalCodeEditor: platform specific files

if (WIN32)
  list (APPEND CPPFILES ExternalCodeEditor_WIN32.cxx)
else ()
  list (APPEND CPPFILES ExternalCodeEditor_UNIX.cxx)
endif (WIN32)

if (APPLE AND (NOT OPTION_APPLE_X11))
  set (ICON_NAME fluid.icns)
  set (ICON_PATH "${CMAKE_CURRENT_SOURCE_DIR}/icons/${ICON_NAME}")
  add_executable (fluid MACOSX_BUNDLE ${CPPFILES} ${ICON_PATH})

  # create macOS bundle wrapper script

  set (WRAPPER "${EXECUTABLE_OUTPUT_PATH}/${CMAKE_CFG_INTDIR}/fluid")
  add_custom_command (
    TARGET fluid POST_BUILD
    COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/../CMake/macOS-bundle-wrapper.in ${WRAPPER}
    COMMAND chmod u+x,g+x,o+x ${WRAPPER}
    BYPRODUCTS ${WRAPPER}
    # COMMENT "Creating macOS bundle wrapper script ${WRAPPER}"
    VERBATIM
  )
  unset (WRAPPER)

else ()
  add_executable (fluid WIN32 ${CPPFILES})
endif (APPLE AND (NOT OPTION_APPLE_X11))

target_link_libraries (fluid fltk fltk_images fltk_forms)
if (FLTK_HAVE_CAIRO)
  if (CMAKE_VERSION VERSION_LESS "3.13")
    link_directories (${PKG_CAIRO_LIBRARY_DIRS})
  else()
    target_link_directories (fluid PRIVATE ${PKG_CAIRO_LIBRARY_DIRS})
  endif()
endif (FLTK_HAVE_CAIRO)

# install fluid

if (APPLE AND (NOT OPTION_APPLE_X11))
  # create bundle
  set_target_properties (fluid PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/fluid.plist")
  set_target_properties (fluid PROPERTIES MACOSX_BUNDLE_ICON_FILE ${ICON_NAME})
  set_target_properties (fluid PROPERTIES RESOURCE ${ICON_PATH})
  # install
  install (TARGETS fluid DESTINATION ${FLTK_BINDIR})
else()
  install (TARGETS fluid
    EXPORT FLTK-Targets
    RUNTIME DESTINATION ${FLTK_BINDIR}
    LIBRARY DESTINATION ${FLTK_LIBDIR}
    ARCHIVE DESTINATION ${FLTK_LIBDIR}
  )
endif (APPLE AND (NOT OPTION_APPLE_X11))

# install desktop files

if (UNIX)
  install (FILES fluid.desktop
    DESTINATION ${FLTK_DATADIR}/applications
  )
  # Install mime-type file (x-fluid.desktop method is deprecated)
  install (FILES fluid.xml
    DESTINATION ${FLTK_DATADIR}/mime/packages
  )

  # Install desktop icons
  foreach (icon 32 48 64 128)
    install (FILES icons/fluid-${icon}.png
      DESTINATION ${FLTK_DATADIR}/icons/hicolor/${icon}x${icon}/apps
      RENAME fluid.png
    )
  endforeach()
endif (UNIX)

=== debian/changelog ===
fltk1.3 (1.3.8-6.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:59:12 +0000

fltk1.3 (1.3.8-6.1build1) noble; urgency=high

  * No change rebuild against libpng16-16t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 25 Mar 2024 14:51:07 +0100

fltk1.3 (1.3.8-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063115

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 13:06:11 +0000

fltk1.3 (1.3.8-6) unstable; urgency=medium

  * debian/FLTK-Targets-none-tail.cmake: Properly honor FLTK_SKIP_FLUID
    when built with CMake 3.24+, which uses _cmake_import_check_targets
    rather than _IMPORT_CHECK_TARGETS.  (Closes: #1028165.)
  * Standards-Version: 4.6.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 15 Nov 2023 21:05:08 -0500

fltk1.3 (1.3.8-5) unstable; urgency=medium

  * debian/fix-fltk-targets: Report command lines, which are now dynamic.
    (See debian/rules changes below.)
  * debian/libfltk*.symbols*: Accommodate LTO builds, which drop some
    symbols (none of which anything in the archive uses AFAICT).
    Specifically, pull out libfltk*.symbols.no-lto files and include them
    with the "(optional)" tag.  (Closes: #1015406.)
  * debian/**lintian-overrides: Add wildcards to accommodate pointed hints.
  * debian/rules:
    - Unhardcode path to stock FLTK-Targets(-none).cmake.
      Per https://gitlab.kitware.com/cmake/cmake/-/issues/23883,
      CMakeTmp/CMakeFiles/Export's subdirectory names are hexadecimal MD5
      hash values as of CMake 3.24; automatic detection allows backports
      to keep working and accommodates possible future layout changes.
      (Closes: #1017271.)
    - Inventory the final FLTK-Targets(-none).cmake files' add_* calls,
      automatically catching blatant problems and making some potential
      others immediately visible in build logs.
  * documentation/Makefile: Use English ("C") month names for PDF date.
    (Closes: #1017421.)
  * Standards-Version: 4.6.1 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 07 Sep 2022 23:16:48 -0400

fltk1.3 (1.3.8-4) unstable; urgency=medium

  * debian/copyright: Update years and png authors.  (NB: Debian still
    doesn't use that tree, or FLTK's other convenience library copies.)
  * CMake/UseFLTK.cmake.in: Drop include_directories setting, which has
    never been useful for package builds.  It historically wound up
    listing the standard system directory /usr/include, and now lists the
    build directory and a subdirectory thereof, harming reproducibility
    and breaking multiarch coinstallability for libfltk1.3-dev.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 23 Jan 2022 20:24:56 -0500

fltk1.3 (1.3.8-3) unstable; urgency=medium

  * debian/rules: More fltk-config handling cleanups, now fixing builds
    covering only architecture-independent binary packages.
    - Remove debian/tmp/usr/bin/fltk-config from
      override_dh_auto_install-indep, not just ...-arch.
    - Retire override_dh_install-arch, now superfluous even in full builds.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 16 Jan 2022 20:43:41 -0500

fltk1.3 (1.3.8-2) unstable; urgency=medium

  * debian/rules: Don't count on debian/tmp/usr/bin/fltk-config.  In
    particular, in builds that cover only architecture-dependent binary
    packages, override_dh_auto_install-indep won't recreate the file
    between override_dh_auto_install-arch and override_dh_install-arch.

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 15 Jan 2022 23:33:09 -0500

fltk1.3 (1.3.8-1) unstable; urgency=medium

  [ Aaron M. Ucko ]
  * New upstream release.
  * debian/FLTK-Targets-head.cmake: New, to obtain DEB_HOST_MULTIARCH from
    dpkg-architecture.
  * debian/{FLTK-Targets-none-tail.cmake,fix-fltk-targets}: Split up
    fix-fltk-targets-none.
  * debian/control:
    - Have libfltk1.3-dev depend on dpkg-dev for dpkg-architecture.
    - Make libfltk1.3-dev multi-arch: same, as enabled by other changes in
      this Debian release.  (Closes: #1002579).
    - Stop worrying about Doxygen-unfriendly old texlive-latex-extra versions.
    - Standards-Version: 4.6.0 (already compliant).
  * debian/fix-fltk-targets: Substitute ${DEB_HOST_MULTIARCH} for the
    architecture-specific value.
  * debian/libfltk1.3.symbols: Add the one new symbol.
  * debian/rules:
    - Extend fix-fltk-targets to FLTK-Targets.cmake, just without the
      additional fragment.
    - For CMake, disable FLTK_BUILD_TEST rather than the deprecated
      OPTION_BUILD_EXAMPLES.
    - Supply a symlink to fltk-config's man page corresponding to its
      architecture-prefixed name.
    - Prepend FLTK-Targets-head.cmake to FLTK-Targets.cmake.
    - Ensure makeinclude always sets USEMMFILES (to No).
  * documentation/Makefile: Drop broken shell FLTK_VERSION setting.  (We
    already have and use a perfectly good makefile setting, whereas the
    shell setting derived from a file that changed names.)

  [ Dima Kogan ]
  * Arrange to install upstream's fltk-config with a GNU-tuple-prefixed
    name; substitute a wrapper that consults dpkg-architecture.

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 15 Jan 2022 21:54:05 -0500

=== debian/control ===
Source: fltk1.3
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Aaron M. Ucko <ucko@debian.org>
Section: libs
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               libcairo2-dev,
               libgl-dev | libgl1-mesa-dev,
               libglu1-mesa-dev | libglu-dev,
               libjpeg-dev,
               libpng-dev,
               libx11-dev,
               libxcursor-dev,
               libxext-dev,
               libxft-dev,
               libxinerama-dev,
               pkg-config,
               zlib1g-dev | libz-dev
Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
                    libasound2-dev [linux-any]
Build-Depends-Indep: doxygen-latex,
                     texlive-font-utils,
                     texlive-latex-extra
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/ucko/fltk1.3
Vcs-Git: https://salsa.debian.org/ucko/fltk1.3.git
Homepage: https://www.fltk.org/
Rules-Requires-Root: no

Package: fluid
Architecture: any
Multi-Arch: foreign
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: fltk1.3-doc,
            libfltk1.3-dev
Description: Fast Light Toolkit - user interface designer
 This package provides Fluid, an interactive GUI designer for FLTK,
 allowing graphical development of FLTK-based user
 interfaces. It natively works with (textual) .fl files, but also
 includes rough support for reading .fd files produced by fdesign (in
 libforms-bin).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: dpkg-dev,
         libfltk-cairo1.3t64 (= ${binary:Version}),
         libfltk-forms1.3t64 (= ${binary:Version}),
         libfltk-gl1.3t64 (= ${binary:Version}),
         libfltk-images1.3t64 (= ${binary:Version}),
         libfltk1.3t64 (= ${binary:Version}),
         libx11-dev,
         ${misc:Depends}
Recommends: fluid,
            libgl-dev,
            libglu1-mesa-dev | libglu-dev
Suggests: fltk1.3-doc,
          libcairo2-dev,
          libjpeg-dev,
          libpng-dev,
          libxext-dev,
          libxft-dev,
          libxinerama-dev,
          zlib1g-dev | libz-dev
Conflicts: libfltk-dev
Provides: libfltk-dev
Replaces: libfltk-dev
Description: Fast Light Toolkit - development files
 This package provides the files necessary for compiling programs
 that depend on FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-compat-headers
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libfltk1.3-dev,
         ${misc:Depends}
Description: Fast Light Toolkit - compatibility header symlinks
 This package provides header symlinks with .h rather than .H extensions for
 compatibility with some older code that relies on the lowercase-h names.

Package: libfltk1.3t64
Provides: ${t64:Provides}
Replaces: libfltk1.3
Breaks: libfltk1.3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - main shared library
 This package contains the files necessary for running programs
 dynamically linked with FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-cairo1.3t64
Provides: ${t64:Provides}
Replaces: libfltk-cairo1.3
Breaks: libfltk-cairo1.3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: libfltk1.3t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - Cairo rendering layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Cairo rendering layer bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-forms1.3t64
Provides: ${t64:Provides}
Replaces: libfltk-forms1.3
Breaks: libfltk-forms1.3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: libfltk1.3t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - Forms compatibility layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Forms compatibility layer.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-gl1.3t64
Provides: ${t64:Provides}
Replaces: libfltk-gl1.3
Breaks: libfltk-gl1.3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: libfltk1.3t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - OpenGL rendering support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's OpenGL rendering bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-images1.3t64
Provides: ${t64:Provides}
Replaces: libfltk-images1.3
Breaks: libfltk-images1.3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: libfltk1.3t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - image loading support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's bindings to image-loading libraries.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Fast Light Toolkit - documentation
 This package provides documentation for FLTK, including a chapter on
 its user interface designer (fluid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-games
Architecture: any
Multi-Arch: foreign
Section: games
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: fltk1.1-games
Replaces: fltk1.1-games
Description: Fast Light Toolkit - example games: checkers, sudoku
 This package contains the example games that accompany FLTK.
 Specifically, it contains the following two programs:
  - flblocks:   clear groups of adjacent blocks before they fill the screen;
  - flcheckers: classic board game, also known as draughts;
  - flsudoku:   Sudoku puzzle (place numbers in a grid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = yes
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

XCFLAGS = -Wall -Wunused -Wno-format-y2k -fPIE -fno-strict-aliasing

libdir = /usr/lib/$(DEB_HOST_MULTIARCH)
GAMES = blocks checkers sudoku
EXTRA_MFLAGS = OPTIM="$(CFLAGS) $(XCFLAGS)" STRIP=@:

FLTK_CONFIG = $(DEB_HOST_GNU_TYPE)-fltk-config
PKG_CONFIG = /usr/bin/$(DEB_HOST_GNU_TYPE)-pkg-config
export PKG_CONFIG

%:
	dh $@

override_dh_autoreconf:
# FLTK uses a hand-maintained configh.in and an autoheader-unfriendly
# configure.ac.
	AUTOHEADER=/bin/true dh_autoreconf

override_dh_auto_clean:
	[ -e fltk.spec.saved ] || mv fltk.spec fltk.spec.saved
# Avoid reconfigure.  Removed by distclean.  >> deliberate -- keeping
# existing contents allows for proper cleaning between builds.
	echo 'RMDIR = rm -Rf' >> makeinclude
	echo 'USEMMFILES = No' >> makeinclude
	dh_auto_clean
	mv fltk.spec.saved fltk.spec

override_dh_clean:
	rm -rf CMakeTmp
	dh_clean documentation/doxygen_sqlite3.db debian/common-build-stamp
	chmod +x debian/fix-fltk-targets debian/fltk-config

override_dh_auto_configure:
	[ -e fltk.spec.saved ] || mv fltk.spec fltk.spec.saved
ifneq "" "$(filter libfltk1.3-dev, $(shell dh_listpackages))"
	mkdir -p CMakeTmp
	dh_auto_configure -S cmake -B CMakeTmp -- -DOPTION_CAIRO:BOOL=ON \
	    -DOPTION_BUILD_SHARED_LIBS:BOOL=ON -DOPTION_CREATE_LINKS:BOOL=ON \
	    -DFLTK_BUILD_TEST:BOOL=OFF
	find CMakeTmp/CMakeFiles/Export -name FLTK-Targets.cmake \
	    -exec debian/fix-fltk-targets debian/FLTK-Targets-head.cmake \
	    {} \; > CMakeTmp/etc/FLTK-Targets.cmake
	find CMakeTmp/CMakeFiles/Export -name FLTK-Targets-none.cmake \
	    -exec debian/fix-fltk-targets {} \
	    debian/FLTK-Targets-none-tail.cmake \; \
	    > CMakeTmp/etc/FLTK-Targets-none.cmake
	grep '^add_' CMakeTmp/etc/FLTK-Targets.cmake
	grep '^add_' CMakeTmp/etc/FLTK-Targets-none.cmake
endif
	dh_auto_configure -- FTCONFIG="$(PKG_CONFIG) freetype2" \
            DSOFLAGS="$(filter-out -fPIE -pie,$(LDFLAGS))" \
	    --enable-shared --enable-cairo --enable-cp936 --with-links \
	    --with-optim=$(filter -O%,$(CXXFLAGS)) --libdir=$(libdir)
	mv fltk.spec.saved fltk.spec

override_dh_auto_build-arch:
	dh_auto_build -- $(EXTRA_MFLAGS) DIRS='$$(IMAGEDIRS) src cairo fluid'
	$(MAKE) -C test $(EXTRA_MFLAGS) $(GAMES)

override_dh_auto_build-indep:
ifneq "" "$(filter nodoc,$(DEB_BUILD_OPTIONS))"
	dh_auto_build -- $(EXTRA_MFLAGS) \
	    DIRS='$$(IMAGEDIRS) src cairo fluid test'
else
	dh_auto_build -- $(EXTRA_MFLAGS)
	$(MAKE) -C documentation html pdf
endif

override_dh_auto_install-arch:
	dh_auto_install -a -- DIRS='$$(IMAGEDIRS) src cairo fluid'
	mkdir -p debian/tmp/usr/games
	mkdir -p debian/tmp/usr/lib/fltk
	mkdir -p debian/tmp/usr/share/applications
	mkdir -p debian/tmp/usr/share/icons/hicolor/32x32/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/128x128/apps
	mkdir -p debian/tmp/usr/share/man/man6
	mkdir -p debian/tmp/usr/share/pixmaps
## fltk1.3-games (installed by hand to be able to add fl prefixes.)
	for game in $(GAMES); do \
	    cp test/$$game debian/tmp/usr/games/fl$$game && \
	    sed -e 's,Exec=,&/usr/games/fl,; s,Icon=,&fl,; s,Name=,&FLTK ,' \
	      test/desktop/$$game.desktop \
	      >debian/tmp/usr/share/applications/fl$$game.desktop && \
	    cp test/desktop/$$game-32.png \
	      debian/tmp/usr/share/icons/hicolor/32x32/apps/fl$$game.png && \
	    cp test/desktop/$$game-128.png \
	      debian/tmp/usr/share/icons/hicolor/128x128/apps/fl$$game.png && \
	    sed -e '1s,^\.TH ,&fl,; 3s,^,fl,' documentation/src/$$game.man \
	      >debian/tmp/usr/share/man/man6/fl$$game.6 \
	    || exit 1; \
	done
## fluid
	$(MAKE) -C fluid install-linux DESTDIR=$(CURDIR)/debian/tmp
## libfltk1.3-dev
	cp debian/CMakeCache.txt CMakeTmp/etc/*.cmake \
	    CMake/FLTK-Functions.cmake debian/tmp/usr/lib/fltk
	sed -e 's/ -f[a-z]*-prefix-map=[^ ]*//' fltk-config \
	    > debian/tmp/usr/bin/$(FLTK_CONFIG)
	chmod 755 debian/tmp/usr/bin/$(FLTK_CONFIG)
	rm -f debian/tmp/usr/bin/fltk-config

  override_dh_auto_install-indep:
ifeq "" "$(filter nodoc,$(DEB_BUILD_OPTIONS))"
	dh_auto_install -i -- DIRS='test'
else
	dh_auto_install -i
endif
	rm -f debian/tmp/usr/bin/fltk-config

override_dh_installdocs:
	dh_installdocs -A CREDITS README

override_dh_installchangelogs:
	dh_installchangelogs CHANGES
	for x in debian/*/usr/share/doc/*/changelog; do \
	    mv -v $$x `dirname $$x`/NEWS; \
	done

override_dh_installman-arch:
	dh_installman
	ln -snfv fltk-config.1 \
	    debian/libfltk1.3-dev/usr/share/man/man1/$(FLTK_CONFIG).1

override_dh_missing:
	dh_missing -Xusr/include/Fl

## fltk1.3 1.3.11

=== documentation/Makefile ===
#
# Makefile for the Fast Light Tool Kit (FLTK) documentation.
#
# Copyright 1998-2020 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#      https://www.fltk.org/bugs.php
#

# Get configuration stuff...
include ../makeinclude

# make sure that all docs are (re-)created independent of missing deps
.PHONY: pdf html refman.pdf

SRC_DOCDIR      = 	./src

# These are the HTML "source" files...
HTMLFILES	= 	 \
			 $(SRC_DOCDIR)/index.dox \
                         $(SRC_DOCDIR)/preface.dox \
                         $(SRC_DOCDIR)/intro.dox \
                         $(SRC_DOCDIR)/basics.dox \
                         $(SRC_DOCDIR)/common.dox \
                         $(SRC_DOCDIR)/editor.dox \
                         $(SRC_DOCDIR)/drawing.dox \
                         $(SRC_DOCDIR)/events.dox \
                         $(SRC_DOCDIR)/subclassing.dox \
                         $(SRC_DOCDIR)/opengl.dox \
                         $(SRC_DOCDIR)/fluid.dox \
                         $(SRC_DOCDIR)/advanced.dox \
                         $(SRC_DOCDIR)/unicode.dox \
                         $(SRC_DOCDIR)/enumerations.dox \
                         $(SRC_DOCDIR)/glut.dox \
                         $(SRC_DOCDIR)/forms.dox \
                         $(SRC_DOCDIR)/osissues.dox \
                         $(SRC_DOCDIR)/migration_1_1.dox \
                         $(SRC_DOCDIR)/migration_1_3.dox \
                         $(SRC_DOCDIR)/development.dox \
                         $(SRC_DOCDIR)/license.dox \
                         $(SRC_DOCDIR)/examples.dox \
                         $(SRC_DOCDIR)/faq.dox

MANPAGES =	$(SRC_DOCDIR)/fltk.$(CAT3EXT) $(SRC_DOCDIR)/fltk-config.$(CAT1EXT) \
		$(SRC_DOCDIR)/fluid.$(CAT1EXT) $(SRC_DOCDIR)/blocks.$(CAT6EXT) \
		$(SRC_DOCDIR)/checkers.$(CAT6EXT) $(SRC_DOCDIR)/sudoku.$(CAT6EXT)

all:	$(MANPAGES)

# Use `make docs' to create all docs for distribution files.
# You need installed versions of Doxygen and LaTeX for this.

docs:	all html pdf

# Synonyms for docs:

alldocs: docs
dist:	docs

clean:
	$(RM) Doxyfile Doxybook
	$(RM) fltk.pdf refman.pdf src/fltk-book.tex src/fltk-book.tex.in
	$(RMDIR) html latex
	$(RM) *~ *.bck *.bak *.log
	$(RM) $(MANPAGES) $(SRC_DOCDIR)/*.0

depend:

install: $(MANPAGES)
	echo "Installing documentation files in $(DESTDIR)$(docdir) ..."
	-$(INSTALL_DIR) $(DESTDIR)$(docdir)
	if test -f html/index.html ; then \
	  for file in html/* ; do \
		$(INSTALL_DATA) $$file $(DESTDIR)$(docdir); \
	  done \
	fi
	if test -f fltk.pdf ; then \
	  echo "Installing fltk.pdf in $(DESTDIR)$(docdir) ..."; \
	  $(INSTALL_DATA) fltk.pdf $(DESTDIR)$(docdir); \
	fi
	echo "Installing man pages in $(DESTDIR)$(mandir) ..."
	-$(INSTALL_DIR) $(DESTDIR)$(mandir)/cat1
	$(INSTALL_MAN) $(SRC_DOCDIR)/fluid.$(CAT1EXT) $(DESTDIR)$(mandir)/cat1
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk-config.$(CAT1EXT) $(DESTDIR)$(mandir)/cat1
	-$(INSTALL_DIR) $(DESTDIR)$(mandir)/cat3
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk.$(CAT3EXT) $(DESTDIR)$(mandir)/cat3
	-$(INSTALL_DIR) $(DESTDIR)$(mandir)/man1
	$(INSTALL_MAN) $(SRC_DOCDIR)/fluid.man $(DESTDIR)$(mandir)/man1/fluid.1
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk-config.man $(DESTDIR)$(mandir)/man1/fltk-config.1
	-$(INSTALL_DIR) $(DESTDIR)$(mandir)/man3
	$(INSTALL_MAN) $(SRC_DOCDIR)/fltk.man $(DESTDIR)$(mandir)/man3/fltk.3

install-linux install-osx:
	-$(INSTALL_DIR) $(DESTDIR)$(mandir)/cat6
	$(INSTALL_MAN) $(SRC_DOCDIR)/blocks.$(CAT6EXT) $(DESTDIR)$(mandir)/cat6
	$(INSTALL_MAN) $(SRC_DOCDIR)/checkers.$(CAT6EXT) $(DESTDIR)$(mandir)/cat6
	$(INSTALL_MAN) $(SRC_DOCDIR)/sudoku.$(CAT6EXT) $(DESTDIR)$(mandir)/cat6
	-$(INSTALL_DIR) $(DESTDIR)$(mandir)/man6
	$(INSTALL_MAN) $(SRC_DOCDIR)/blocks.man $(DESTDIR)$(mandir)/man6/blocks.6
	$(INSTALL_MAN) $(SRC_DOCDIR)/checkers.man $(DESTDIR)$(mandir)/man6/checkers.6
	$(INSTALL_MAN) $(SRC_DOCDIR)/sudoku.man $(DESTDIR)$(mandir)/man6/sudoku.6


uninstall:
	$(RMDIR) $(DESTDIR)$(docdir)
	$(RM) $(DESTDIR)$(mandir)/cat1/fluid.$(CAT1EXT)
	$(RM) $(DESTDIR)$(mandir)/man1/fluid.1
	$(RM) $(DESTDIR)$(mandir)/cat1/fltk-config.$(CAT1EXT)
	$(RM) $(DESTDIR)$(mandir)/man1/fltk-config.1
	$(RM) $(DESTDIR)$(mandir)/cat3/fltk.$(CAT3EXT)
	$(RM) $(DESTDIR)$(mandir)/man3/fltk.3

uninstall-linux uninstall-osx:
	$(RM) $(DESTDIR)$(mandir)/cat6/blocks.$(CAT6EXT)
	$(RM) $(DESTDIR)$(mandir)/cat6/checkers.$(CAT6EXT)
	$(RM) $(DESTDIR)$(mandir)/cat6/sudoku.$(CAT6EXT)
	$(RM) $(DESTDIR)$(mandir)/man6/blocks.6
	$(RM) $(DESTDIR)$(mandir)/man6/checkers.6
	$(RM) $(DESTDIR)$(mandir)/man6/sudoku.6

# The documentation is generated using doxygen. There are two control files
# for doxygen: Doxyfile for html documentation and Doxybook for pdf docs.
# Both files are generated from the common source file Doxyfile.in.
# Note that Doxyfile.in is shared with CMake to configure these files.

Doxyfile: Doxyfile.in
	echo "Generating Doxyfile ..."
	sed -e's,@FLTK_VERSION@,$(FLTK_VERSION),' \
	    -e's,@GENERATE_HTML@,YES,' \
	    -e's,@GENERATE_LATEX@,NO,' \
	    -e's, @LATEX_HEADER@,,' \
	    -e's,@CMAKE_CURRENT_SOURCE_DIR@/,,' \
	    -e's,@FLTK_SOURCE_DIR@/,../,' \
	    < $< > $@

Doxybook: Doxyfile.in
	echo "Generating Doxybook ..."
	sed -e's,@FLTK_VERSION@,$(FLTK_VERSION),' \
	    -e's,@GENERATE_HTML@,NO,' \
	    -e's,@GENERATE_LATEX@,YES,' \
	    -e's,@LATEX_HEADER@,src/fltk-book.tex,' \
	    -e's,@CMAKE_CURRENT_SOURCE_DIR@/,,' \
	    -e's,@FLTK_SOURCE_DIR@/,../,' \
	    < $< > $@

# The HTML files are generated using doxygen, and this needs
# an installed doxygen version and may take some time, so this target
# is not made by default.
# Use `make html' or `make docs' to create the html docs.

html:	$(HTMLFILES) Doxyfile
	echo "Generating HTML documentation..."
	-$(RMDIR) html
	-$(INSTALL_DIR) html
	-$(DOXYDOC)
	if test "x$(DOXYDOC)" = "x" ; then \
	  echo "Sorry - doxygen not found. Please install doxygen and run configure."; \
	fi
	test -d html && cp src/tiny.png html/

# The PDF documentation (fltk.pdf) is generated using doxygen and LaTeX, and
# this needs installed Doxygen and LaTeX programs and may take some time, so
# this target is not made by default.
# Use `make pdf' or `make docs' to create the PDF docs.

pdf:	refman.pdf
	cp -f latex/refman.pdf fltk.pdf

refman.pdf: $(HTMLFILES) Doxybook src/fltk-book.tex
	-$(RMDIR) latex
	echo "Generating PDF documentation ..."
	$(DOXYDOC) Doxybook
	./make_pdf

src/fltk-book.tex: src/fltk-book.tex.in
	echo "Generating $@ ..."
	DOXY_VERSION=`$(DOXYDOC) --version|cut -f1 -d' '`; \
	YEAR=`date +%Y`; \
	sed -e"s/@YEAR@/$$YEAR/g" \
	    -e"s/@FLTK_VERSION@/$(FLTK_VERSION)/g" \
	    -e"s/@DOXY_VERSION@/$$DOXY_VERSION/g" \
	< $< > $@

src/fltk-book.tex.in: src/fltk-title.tex.in
	echo "Generating $@ ..."
	./make_header src/fltk-title.tex.in src/fltk-book.tex.in

=== jpeg/CMakeLists.txt ===
#
# JPEG library CMake configuration for the Fast Light Toolkit (FLTK).
#
# Copyright 1998-2023 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

# memmgr back ends: compile only one of these into a working library
# (For now, let's use the mode that requires the image fit into memory.
# This is the recommended mode for Win32 anyway.)

set (systemdependent_SRCS jmemnobs.c)

# library object files common to compression and decompression

set (common_SRCS
     jaricom.c jcomapi.c jutils.c jerror.c jmemmgr.c
)

# compression library object files

set (compression_SRCS
     jcapimin.c jcapistd.c jcarith.c jctrans.c jcparam.c jdatadst.c jcinit.c
     jcmaster.c jcmarker.c jcmainct.c jcprepct.c jccoefct.c jccolor.c
     jcsample.c jchuff.c jcdctmgr.c jfdctfst.c jfdctflt.c
     jfdctint.c
)

# decompression library object files

set (decompression_SRCS
     jdapimin.c jdapistd.c jdarith.c jdtrans.c jdatasrc.c jdmaster.c
     jdinput.c jdmarker.c jdhuff.c jdmainct.c jdcoefct.c
     jdpostct.c jddctmgr.c jidctfst.c jidctflt.c jidctint.c
     jdsample.c jdcolor.c jquant1.c jquant2.c jdmerge.c
)

list (APPEND BUILD_SRCS "${systemdependent_SRCS};${common_SRCS}")
list (APPEND BUILD_SRCS "${compression_SRCS};${decompression_SRCS}")

#######################################################################

# Suppress some Visual Studio compiler warnings

set (msvc_warnings /wd4267)

#######################################################################
# Build the static library
#######################################################################

FL_ADD_LIBRARY (fltk_jpeg STATIC "${BUILD_SRCS}")

if (MSVC)
  target_compile_options (fltk_jpeg PRIVATE ${msvc_warnings})
endif (MSVC)

#######################################################################
# Build the shared library (optional)
#######################################################################

if (OPTION_BUILD_SHARED_LIBS)

  FL_ADD_LIBRARY (fltk_jpeg SHARED "${BUILD_SRCS}")

  if (MSVC)
    target_compile_options (fltk_jpeg_SHARED PRIVATE ${msvc_warnings})
  endif (MSVC)

endif (OPTION_BUILD_SHARED_LIBS)

#######################################################################
# Install the library headers
#######################################################################

install (FILES jconfig.h jerror.h jmorecfg.h jpeglib.h
               fltk_jpeg_prefix.h
         DESTINATION ${FLTK_INCLUDEDIR}/FL/images
)

=== jpeg/Makefile ===
# *************************************************************************
#  FLTK - DO NOT CHANGE when upgrading the JPEG library, unless required. *
# *************************************************************************
#
# JPEG library makefile for the Fast Light Toolkit (FLTK).
#
# Copyright 1997-2023 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

include ../makeinclude

#
# Object files...
#

OBJS	=	\
		jaricom.o \
		jcapimin.o \
		jcapistd.o \
		jcarith.o \
		jccoefct.o \
		jccolor.o \
		jcdctmgr.o \
		jchuff.o \
		jcinit.o \
		jcmainct.o \
		jcmarker.o \
		jcmaster.o \
		jcomapi.o \
		jcparam.o \
		jcprepct.o \
		jcsample.o \
		jctrans.o \
		jdapimin.o \
		jdapistd.o \
		jdarith.o \
		jdatadst.o \
		jdatasrc.o \
		jdcoefct.o \
		jdcolor.o \
		jddctmgr.o \
		jdhuff.o \
		jdinput.o \
		jdmainct.o \
		jdmarker.o \
		jdmaster.o \
		jdmerge.o \
		jdpostct.o \
		jdsample.o \
		jdtrans.o \
		jerror.o \
		jfdctflt.o \
		jfdctfst.o \
		jfdctint.o \
		jidctflt.o \
		jidctfst.o \
		jidctint.o \
		jmemmgr.o \
		jmemnobs.o \
		jquant1.o \
		jquant2.o \
		jutils.o

LIBJPEG	=	../lib/libfltk_jpeg$(LIBEXT)

#
# Make all targets...
#

all:	$(LIBJPEG)

#
# Clean all targets and object files...
#

clean:
	$(RM) $(OBJS)
	$(RM) $(LIBJPEG)

#
# Install everything...
#

install:	$(LIBJPEG)
	echo "Installing $(LIBJPEG) in $(libdir)..."
	-$(INSTALL_DIR) $(DESTDIR)$(libdir)
	$(INSTALL_LIB) $(LIBJPEG) $(DESTDIR)$(libdir)
	$(RANLIB) $(DESTDIR)$(libdir)/libfltk_jpeg$(LIBEXT)
	echo "Installing jpeg headers in $(includedir)/FL/images..."
	-$(INSTALL_DIR) $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) jconfig.h $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) jerror.h $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) jmorecfg.h $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) jpeglib.h $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) fltk_jpeg_prefix.h $(DESTDIR)$(includedir)/FL/images

#
# Uninstall everything...
#

uninstall:
	echo "Uninstalling libfltk_jpeg$(LIBEXT) in $(libdir)..."
	$(RM) $(libdir)/libfltk_jpeg$(LIBEXT)
	echo "Uninstalling jpeg headers in $(includedir)/FL/images..."
	$(RM) $(includedir)/FL/images/jconfig.h
	$(RM) $(includedir)/FL/images/jerror.h
	$(RM) $(includedir)/FL/images/jmorecfg.h
	$(RM) $(includedir)/FL/images/jpeglib.h
	$(RM) $(includedir)/FL/images/fltk_jpeg_prefix.h

#
# libfltk_jpeg.a
#

$(LIBJPEG):	$(OBJS)
	echo Archiving $@...
	$(RM) $@
	$(LIBCOMMAND) $@ $(OBJS)
	$(RANLIB) $@

#
# Make dependencies...
#

depend: $(OBJS:.o=.c)
	makedepend -Y -I.. -f makedepend -w 20 $(OBJS:.o=.c)
	echo "# DO NOT DELETE THIS LINE -- make depend depends on it." > makedepend.tmp
	echo "" >> makedepend.tmp
	grep '^[a-zA-Z]' makedepend | ( LC_ALL=C sort -u -f >> makedepend.tmp; )
	mv makedepend.tmp makedepend

include makedepend

$(OBJS):	../makeinclude

=== zlib/Makefile ===
#
# ZIP library makefile for the Fast Light Toolkit (FLTK).
#
# Copyright 1998-2023 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#     https://www.fltk.org/bugs.php
#

include ../makeinclude

#
# Object files...
#

OBJS	=	adler32.o compress.o crc32.o uncompr.o deflate.o \
		trees.o zutil.o inflate.o inftrees.o inffast.o \
		gzclose.o gzlib.o gzread.o gzwrite.o infback.o

LIBZ	=	../lib/libfltk_z$(LIBEXT)

#
# Make all targets...
#

all:	$(LIBZ)

#
# Clean all targets and object files...
#

clean:
	$(RM) $(OBJS)
	$(RM) $(LIBZ)

#
# Install everything...
#

install: $(LIBZ)
	echo "Installing libfltk_z$(LIBEXT) in $(libdir)..."
	-$(INSTALL_DIR) $(DESTDIR)$(libdir)
	$(INSTALL_LIB) $(LIBZ) $(DESTDIR)$(libdir)
	$(RANLIB) $(DESTDIR)$(libdir)/libfltk_z$(LIBEXT)
	echo "Installing zlib headers in $(includedir)/FL/images..."
	-$(INSTALL_DIR) $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) zconf.h $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) zlib.h $(DESTDIR)$(includedir)/FL/images
	$(INSTALL_DATA) zutil.h $(DESTDIR)$(includedir)/FL/images

#
# Uninstall everything...
#

uninstall:
	echo "Uninstalling libfltk_z$(LIBEXT) in $(libdir)..."
	$(RM) $(libdir)/libfltk_z$(LIBEXT)
	echo "Uninstalling zlib headers in $(includedir)/FL/images..."
	$(RM) $(includedir)/FL/images/zconf.h
	$(RM) $(includedir)/FL/images/zlib.h
	$(RM) $(includedir)/FL/images/zutil.h

#
# libfltk_z.a
#

$(LIBZ):	$(OBJS)
	echo Archiving $@...
	$(RM) $@
	$(LIBCOMMAND) $@ $(OBJS)
	$(RANLIB) $@

#
# Make dependencies...
#

depend: $(OBJS:.o=.c)
	makedepend -Y -I.. -f makedepend -w 20 $(OBJS:.o=.c)
	echo "# DO NOT DELETE THIS LINE -- make depend depends on it." > makedepend.tmp
	echo "" >> makedepend.tmp
	grep '^[a-zA-Z]' makedepend | ( LC_ALL=C sort -u -f >> makedepend.tmp; )
	mv makedepend.tmp makedepend

include makedepend

$(OBJS):	../makeinclude

=== debian/changelog ===
fltk1.3 (1.3.11-3) unstable; urgency=medium

  * debian/control:
    - Build-depend on texlive-fonts-extra so that PDF documentation can
      include the Apple logo (from Font Awesome 5) for completeness.
    - Reflect the move to the new Debian FLTK Ecosystem Team (albeit with
      myself as the only uploader, at least for now) and corresponding new
      Salsa group.
    - Reformat via "cme fix dpkg-control" (routine-update).
  * documentation/Doxyfile.in: Use the new latex-extras.sty.
  * documentation/Makefile: Have refman.pdf depend on it.
  * documentation/latex-extras.sty (new):
    - Supply a fallback definition of \insert@pcolumn based on the
      traditional (late 1980s-2023) definition of \insert@column to work
      around an incompatibility between the old version of array.sty
      Doxygen's preserved copy of archaic tabu.sty requires and other
      portions of TeX Live 2025.  (Closes: #1112922.)
    - Ensure LaTeX knows what to make of all Unicode characters in the
      input, even U+F8FF (private-use, the Apple logo in this context).

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 14 Oct 2025 22:00:43 -0400

fltk1.3 (1.3.11-2) unstable; urgency=medium

  * debian/control: Drop fluid (in favor of fltk1.4's) on hurd-any too,
    leaving only x32.  (CMake is unavailable on x32, making both 1.3 and
    1.4 unbuildable; if and when that gets fixed, a fluidless 1.3 might
    wind up building ahead of 1.4.  Meanwhile, the 1.4 packaging now
    properly accounts for the fact that Wayland-related build
    dependencies, including libdecor, are Linux-only.)
  * debian/rules: Suppress AppStream metadata generation for games to
    avoid duplicating component IDs with the 1.4 versions.  (Don't bother
    special-casing x32 on this one.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 30 Apr 2025 21:41:08 -0400

fltk1.3 (1.3.11-1) unstable; urgency=high

  * New upstream point release.
  * debian/control: Limit fluid's architectures to hurd-any and x32,
    at least for now.
  * debian/rules: Conditionalize fluid installation (but always still
    build it for internal use).
  * debian/control:
    - Explicitly account for libfltk*-compat-headers' overlap.
      (See #1102681.)
    - Build-depend on pkgconf, not legacy pkg-config.
  * debian/copyright: Substitute a URL for the FSF's postal address.
    (See #1080497.)
  * debian/watch: Belatedly recognize multi-digit patch levels.
  * test/Makefile: Actually enable shared linkage for e.g. games.  I'd
    accidentally committed the relevant settings in commented-out form.
  * Standards-Version: 4.7.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 11 Apr 2025 18:47:54 -0400

=== debian/control ===
Source: fltk1.3
Standards-Version: 4.7.2
Maintainer: Debian FLTK Ecosystem Team <team+fltk@tracker.debian.org>
Uploaders:
 Aaron M. Ucko <ucko@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 libcairo2-dev,
 libgl-dev | libgl1-mesa-dev,
 libglu1-mesa-dev | libglu-dev,
 libjpeg-dev,
 libpng-dev,
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxft-dev,
 libxinerama-dev,
 pkgconf,
 zlib1g-dev | libz-dev,
Build-Depends-Arch:
 dpkg-dev (>= 1.22.5),
 cmake,
 libasound2-dev [linux-any],
Build-Depends-Indep:
 doxygen-latex,
 texlive-font-utils,
 texlive-fonts-extra,
 texlive-latex-extra,
Vcs-Browser: https://salsa.debian.org/fltk-team/fltk1.3
Vcs-Git: https://salsa.debian.org/fltk-team/fltk1.3.git
Homepage: https://www.fltk.org/
Rules-Requires-Root: no

Package: fluid
Architecture: x32
Multi-Arch: foreign
Section: devel
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fltk1.3-doc,
 libfltk1.3-dev,
Description: Fast Light Toolkit - user interface designer
 This package provides Fluid, an interactive GUI designer for FLTK,
 allowing graphical development of FLTK-based user
 interfaces. It natively works with (textual) .fl files, but also
 includes rough support for reading .fd files produced by fdesign (in
 libforms-bin).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 dpkg-dev,
 libfltk-cairo1.3t64 (= ${binary:Version}),
 libfltk-forms1.3t64 (= ${binary:Version}),
 libfltk-gl1.3t64 (= ${binary:Version}),
 libfltk-images1.3t64 (= ${binary:Version}),
 libfltk1.3t64 (= ${binary:Version}),
 libx11-dev,
 ${misc:Depends},
Recommends:
 fluid,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
Suggests:
 fltk1.3-doc,
 libcairo2-dev,
 libjpeg-dev,
 libpng-dev,
 libxext-dev,
 libxft-dev,
 libxinerama-dev,
 zlib1g-dev | libz-dev,
Conflicts:
 libfltk-dev,
Provides:
 libfltk-dev,
Replaces:
 libfltk-dev,
Description: Fast Light Toolkit - development files
 This package provides the files necessary for compiling programs
 that depend on FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-compat-headers
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends:
 libfltk1.3-dev,
 ${misc:Depends},
Conflicts:
 libfltk1.4-compat-headers,
 libfltk-compat-headers,
Provides:
 libfltk1.4-compat-headers,
 libfltk-compat-headers,
Replaces:
 libfltk1.4-compat-headers,
 libfltk-compat-headers,
Description: Fast Light Toolkit - compatibility header symlinks
 This package provides header symlinks with .h rather than .H extensions for
 compatibility with some older code that relies on the lowercase-h names.

Package: libfltk1.3t64
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 libfltk1.3 (<< ${source:Version}),
Provides:
 ${t64:Provides},
Replaces:
 libfltk1.3,
Description: Fast Light Toolkit - main shared library
 This package contains the files necessary for running programs
 dynamically linked with FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-cairo1.3t64
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 libfltk-cairo1.3 (<< ${source:Version}),
Provides:
 ${t64:Provides},
Replaces:
 libfltk-cairo1.3,
Description: Fast Light Toolkit - Cairo rendering layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Cairo rendering layer bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-forms1.3t64
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 libfltk-forms1.3 (<< ${source:Version}),
Provides:
 ${t64:Provides},
Replaces:
 libfltk-forms1.3,
Description: Fast Light Toolkit - Forms compatibility layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Forms compatibility layer.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-gl1.3t64
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 libfltk-gl1.3 (<< ${source:Version}),
Provides:
 ${t64:Provides},
Replaces:
 libfltk-gl1.3,
Description: Fast Light Toolkit - OpenGL rendering support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's OpenGL rendering bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-images1.3t64
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 libfltk-images1.3 (<< ${source:Version}),
Provides:
 ${t64:Provides},
Replaces:
 libfltk-images1.3,
Description: Fast Light Toolkit - image loading support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's bindings to image-loading libraries.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: Fast Light Toolkit - documentation
 This package provides documentation for FLTK, including a chapter on
 its user interface designer (fluid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-games
Architecture: any
Multi-Arch: foreign
Section: games
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 fltk1.1-games,
Replaces:
 fltk1.1-games,
Description: Fast Light Toolkit - example games: checkers, sudoku
 This package contains the example games that accompany FLTK.
 Specifically, it contains the following two programs:
  - flblocks:   clear groups of adjacent blocks before they fill the screen;
  - flcheckers: classic board game, also known as draughts;
  - flsudoku:   Sudoku puzzle (place numbers in a grid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,8 @@
 FLTK_CONFIG = $(DEB_HOST_GNU_TYPE)-fltk-config
 PKG_CONFIG = /usr/bin/$(DEB_HOST_GNU_TYPE)-pkg-config
 export PKG_CONFIG
+
+FLUID := $(filter fluid, $(shell dh_listpackages))
 
 %:
 	dh $@
@@ -74,7 +76,7 @@
 endif
 
 override_dh_auto_install-arch:
-	dh_auto_install -a -- DIRS='$$(IMAGEDIRS) src cairo fluid'
+	dh_auto_install -a -- DIRS='$$(IMAGEDIRS) src cairo $(FLUID)'
 	mkdir -p debian/tmp/usr/games
 	mkdir -p debian/tmp/usr/lib/fltk
 	mkdir -p debian/tmp/usr/share/applications
@@ -88,6 +90,8 @@
 	    sed -e 's,Exec=,&/usr/games/fl,; s,Icon=,&fl,; s,Name=,&FLTK ,' \
 	      test/desktop/$$game.desktop \
 	      >debian/tmp/usr/share/applications/fl$$game.desktop && \
+	    echo 'X-AppStream-Ignore=true' \
+	      >>debian/tmp/usr/share/applications/fl$$game.desktop && \
 	    cp test/desktop/$$game-32.png \
 	      debian/tmp/usr/share/icons/hicolor/32x32/apps/fl$$game.png && \
 	    cp test/desktop/$$game-128.png \
@@ -96,8 +100,9 @@
 	      >debian/tmp/usr/share/man/man6/fl$$game.6 \
 	    || exit 1; \
 	done
-## fluid
+ifneq "" "$(FLUID)"
 	$(MAKE) -C fluid install-linux DESTDIR=$(CURDIR)/debian/tmp
+endif
 ## libfltk1.3-dev
 	cp debian/CMakeCache.txt CMakeTmp/etc/*.cmake \
 	    CMake/FLTK-Functions.cmake debian/tmp/usr/lib/fltk

=== debian/watch ===
version=4
opts="downloadurlmangle=s|.*FILE=|ftp://ftp.easysw.com/pub/|,uversionmangle=s|rc|~rc|;s|\.x-|~|" \
https://www.fltk.org/software.php .*/fltk-(1\.3\.\d*)(?:-\d+)?-source\.tar\.gz
